
;TV's server version 3.10
;Copyright (c) 2014 - 2019, Tycho Veltmeijer.
;All rights reserved.

GetProtocolNames equ 0
StartProtocol equ 1
BindToProtocolCallBack equ 2
StartListening equ 3
HandleConnection equ 4
RecvData equ 5
SendData equ 6
CloseClientSession equ 7
GetClientSessionInfo equ 8
PrepareCloseListenSession equ 9
CloseListenSession equ 10

import_list_size equ psize*11

export_list_size equ endExportList - beginExportList
beginExportList:
pointer     __asm_set_export_table,\
            GetAPIVersion_asm,\
            SetProtocolInformation_asm,\
            SetControlPanelOptions_asm,\
            AcceptProtocol_asm,\
            SavePluginData_asm,\
            GetPluginData_asm,\
            FindProtocolDataStruct_asm,\
            RequestToBindToNextProtocol_asm,\
            CallNextHandleConnection_asm,\
            RecvData_asm,\
            SendData_asm,\
            CloseClientSession_asm,\
            GetClientSessionInfo_asm,\
            CloseListenSession_asm,\
            FormatDate_asm,\
            FormatTime_asm,\
            FormatDateTime_asm,\
            CountListRows_asm,\
            AddListRow_asm,\
            GetListItem_asm,\
            GetListItemSize_asm,\
            SetListItem_asm,\
            RemoveListRow_asm,\
            FindListItem_asm,\ ;added!!!
            CloseProtocolSession_asm,\
            RecoverDateTime_asm,\
            GetCopyOfInternalProtocolStructures_asm,\
            ReleaseCopyOfInternalProtocolStructures_asm,\
            GetCopyOfInternalListenStructure_asm,\
            ReleaseCopyOfInternalListenStructure_asm,\
            RegisterProtocolLoadedCallbackFunction_asm,\
            CountListenSessions_asm,\
            RegisterListenSessionIsCreatedCallbackFunction_asm,\
            GetCopyOfInternalListenStructureByLsess_asm,\
            RecoverTime_asm,\
            RecoverDate_asm,\
            BindToProtocol_asm,\
            GetListenSessionFromClientSession_asm,\
            CloseListenSessionEx_asm,\
            ShutdownServer_asm
          if used New_Memory_management
            if used checkOnBufferOverflow
              pointer _ExtCheckOnbufferOverflow
            end if
          end if

endExportList:

if used New_Memory_management
  if used checkOnBufferOverflow
    _ExtCheckOnbufferOverflow:
      call denter

      call getLockPointerStructure
      push [bacukpAllocatedMemory]
      push [AllocatedMemory]
      call compairBackup
      call releaseLockPointerStructure

      call dleave
    ret
  end if
end if

beginExportList_c:
pointer     __asm_set_export_table_c,\
            GetAPIVersion_asm,\
            SetProtocolInformation_c,\
            SetControlPanelOptions_c,\
            AcceptProtocol_c,\
            SavePluginData_c,\
            GetPluginData_c,\
            FindProtocolDataStruct_c,\
            RequestToBindToNextProtocol_c,\
            CallNextHandleConnection_c,\
            RecvData_c,\
            SendData_c,\
            CloseClientSession_c,\
            GetClientSessionInfo_c,\
            CloseListenSession_c,\
            FormatDate_c,\
            FormatTime_c,\
            FormatDateTime_c,\
            CountListRows_c,\
            AddListRow_c,\
            GetListItem_c,\
            GetListItemSize_c,\
            SetListItem_c,\
            RemoveListRow_c,\
            FindListItem_c,\ ;added!!!
            CloseProtocolSession_c,\
            RecoverDateTime_c,\
            GetCopyOfInternalProtocolStructures_c,\
            ReleaseCopyOfInternalProtocolStructures_c,\
            GetCopyOfInternalListenStructure_c,\
            ReleaseCopyOfInternalListenStructure_c,\
            RegisterProtocolLoadedCallbackFunction_c,\
            CountListenSessions_c,\
            RegisterListenSessionIsCreatedCallbackFunction_c,\
            GetCopyOfInternalListenStructureByLsess_c,\
            RecoverTime_c,\
            RecoverDate_c,\
            BindToProtocol_c,\
            GetListenSessionFromClientSession_c,\
            CloseListenSessionEx_c,\
            ShutdownServer_c
endExportList_c:


  __asm_exchange_tables_name db '__asm_exchange_tables',0
