@echo off
net session >nul 2>&1
if %errorLevel%==0 goto runningasadmin

set "batchPath=%~f0"

echo This script needs admin priviliges to be able to install TV's server v3.01.
echo Starting as admin...
REM Try to start the script with admin priviliges
ECHO Set UAC = CreateObject^("Shell.Application"^) > "%temp%\OEgetPrivileges.vbs"
ECHO UAC.ShellExecute "cmd", "/c ""%batchPath% """, "%~dp0\", "runas", 1 >> "%temp%\OEgetPrivileges.vbs"
"%temp%\OEgetPrivileges.vbs" 
exit /B

:runningasadmin
cd %~dp0
SET @DIR=%~dp0
%@DIR:~0,2%

echo This will 
echo  - stop and uninstall the service TV's server from the system
echo  - Optionally removes settings from the registry
echo Would you like to continue?
pause

SET @BASE_NUMBER=32
set @REGISTRY_BASE=HKLM\SOFTWARE\TV's software\TV's server v3

if not "%PROCESSOR_ARCHITECTURE%"=="AMD64" goto 32BIT
set @REGISTRY_BASE=HKLM\SOFTWARE\WOW6432Node\TV's software\TV's server v3
:loop
echo Would you like to uninstall the 32-bit version or the 64-bit version?
echo --
echo 1:32-bit
echo 2:64-bit
set /p id="Enter [1-2, default 2]: "
if "%id%"=="" goto 64BIT
if %id%==1 goto 32BIT
if not %id%==2 goto loop

:64BIT
set @REGISTRY_BASE=HKLM\SOFTWARE\TV's software\TV's server v3
SET @BASE_NUMBER=64

:32BIT
:askUser
set /p remove="Would you like to remove the settings from the registry? (this cannot be undone) [Y/N, default yes]: "
if "%remove%"=="" (
  set remove=y
  goto userHasChosen
)
if %remove%==Y (
  set remove=y
  goto userHasChosen
)
if %remove%==N (
  set remove=n
  goto userHasChosen
)
if %remove%==y goto userHasChosen
if not %remove%==n goto askUser

:userHasChosen
echo Stoppping and uninstalling service...
start /wait base%@BASE_NUMBER%_win.exe -u

if %remove%==y (
  echo Removing settings from registry
  reg DELETE "%@REGISTRY_BASE%" /f
)

echo done
pause