;------------------------------------------------------------------------------
;This function will call a system function on 64 with 0-4 argument(s) (makes stack and stuff)
;input:
;    1:function
;    2:arg
;output:
;    (R/E)AX => output function
;------------------------------------------------------------------------------
macro mfcall func,argc
{ common
if used is64
  push argc
  push func
  call funccall
  if argc=0
  else
    add pesp,psize*argc
  end if
else
  call func
end if
}

if used is64
  funccall:
  call denter
  MakeStack

  mov ebx,dword [rbp+psize*3] ;arg count
  test ebx,ebx
  jz ..noArg

  argpush 1,pdword [pebp+psize*4]
  dec ebx
  jz ..noArg

  argpush 2,pdword [pebp+psize*5]
  dec ebx
  jz ..noArg

  argpush 3,pdword [pebp+psize*6]
  dec ebx
  jz ..noArg

  argpush 4,pdword [pebp+psize*7]

  ..noArg:
  call pdword [pebp+psize*2]

  call dleave
  ret psize*2
end if